package hu.unideb.ai.jars;

import java.util.ArrayList;
import java.util.List;

public class BackTrack {

	static class Node {
		State state;
		Node parent;
		Operator creator;
		List<Operator> unused;
	}
	
	
	public static void main(String[] args) {
		search();
	}
	
	public static void search() {
		// DATABASE
		Node actualNode;
		
		// CONTROLLER
		actualNode = new Node();
		actualNode.state = State.start();
		actualNode.parent = null;
		actualNode.creator = null;
		actualNode.unused = new ArrayList<>();
		for (Operator o : Operator.operators)
			if (o.isApplicable(actualNode.state))
				actualNode.unused.add(o);
		
		final int limit = 4;
		int length = 1;
		while (true) {
			
			if ( actualNode.state.isGoal() ) {
				System.out.println(actualNode.state);
				break;
			} 
			
			if ( ! actualNode.unused.isEmpty() &&  length < limit ) {
				Operator o = actualNode.unused.remove(0);
				length++;
				
				Node newNode = new Node();
				newNode.state = o.apply(actualNode.state);
				newNode.parent = actualNode;
				newNode.creator = o;
				newNode.unused = new ArrayList<>();
				for (Operator oo : Operator.operators)
					if (oo.isApplicable(newNode.state))
						newNode.unused.add(oo);
				actualNode = newNode;
				
			} else {
				if ( actualNode.parent == null ) {
					System.out.println(":-(");
					break;
				}
				length--;
				actualNode = actualNode.parent;
			}
			
			
		}
		
		
		
		
	}
	
}
