package hu.unideb.ai.jars;

public class Operator {

	private final int i;
	
	private final int j;

	public Operator(int i, int j) {
		super();
		this.i = i;
		this.j = j;
	}
	
	static final int[] max = new int[4];
	
	static {
		max[1] = 5;
		max[2] = 3;
		max[3] = 2;
	}
	
	public boolean isApplicable(State state) {
		return state.a[i] > 0 && state.a[j] < max[j];
	}
	
	public State apply(State state) {
		State newState = new State();
		int m = Math.min(state.a[i], max[j]-state.a[j]);
		for (int k=1; k<=3; k++)
			if (k==j)
				newState.a[k] = state.a[k] + m;
			else if (k==i)
				newState.a[k] = state.a[k] - m;
			else 
				newState.a[k] = state.a[k];
		return newState;
	}
	
	public double cost(State state) {
		return Math.min(state.a[i], max[j]-state.a[j]);
	}
	
	
	public final static  Operator[] operators = {
			new Operator(1, 2),	
			new Operator(1, 3),	
			new Operator(2, 1),	
			new Operator(2, 3),	
			new Operator(3, 1),	
			new Operator(3, 2),	
	};
	
	@Override
	public String toString() {
		return new StringBuffer().append(i).append(" -> ").append(j).toString();
	}
	
}
