package hu.unideb.ai.jars;

import java.util.ArrayList;
import java.util.Random;

public class TrialAndError {

	public static void main(String[] args) {
		for ( int i = 0; i < 1000; i++ )
			search();
	}
	
	public static void search() {
		// DATABASE:
		State actualState;
		
		// CONTROLLER:
		actualState = State.start();
		int counter = 0;
		while (true) {
			
			if (actualState.isGoal()) {
				System.out.println(actualState);
				break;
			}
			
			ArrayList<Operator> applicables = new ArrayList<Operator>();
			for ( Operator o : Operator.operators )
				if ( o.isApplicable(actualState) )
					applicables.add(o);
			
			if (applicables.isEmpty()) {
				System.out.println(" :-( ");
				break;
			}
			
			Random random = new Random();
			Operator o = applicables.get(random.nextInt(applicables.size()));
			
			actualState = o.apply(actualState);
			counter++;
		}
		System.out.print(counter);
	}
	
}
